import PySimpleGUI as sg
from sys import path, platform as PLATFORM
from os import listdir
from PIL import Image
import urllib.request
import json
import io
import configparser

PATH = './Assets/'
BUTTON_DICT = {img[:-4].upper(): PATH + img for img in listdir(PATH)}
DEFAULT_IMG = PATH + 'logo2.png'
ICON = PATH + 'player.ico'
TRACK_COLOR = '#ef984a'
INFO_COLOR = '#7CCECF'
ERROR_COLOR = '#CC0000'

host_url = "http://127.0.0.1:100"
flag_connection = False
Albums = None
Albums2 = None
CurrentAlbumIndex = -1
PlayingAlbumIndex = -1
Playing = False
CurrentSongs = None
Playlists = None
PlaylistIndex = None
PlayingName = None
hasHGlass = False
CurrentSongIndex = -1
PlayingSongIndex = -1
CurrentPlaylistIndex = -1
ErrorString = ''
mp = None
time_t = 0
time_c =0
label_track = ''
CurrentImage = None

RadioMode = False
WinHost = True
IsScanning = False
AddMode = False
CurrentVolume = 0
AlbumListSize = (48,20)
SongListSize = (48,20)
AlbumListSizeCur = AlbumListSize
SongListSizeCur = SongListSize 
ImageSize  = (400, 400)
ImageSizeCur  = ImageSize
BaseWindowSize = (800,600)
CurrentWindowSize = (800,600)
CurrentWindowLocation = (0,0)
PlaylistsSize = (92,26)
PlaylistsSizeCur = PlaylistsSize
RadioPicturesList = []
RadioPictureIndex = 0
PicturesInterval = 20
config = configparser.ConfigParser()

def errorinfo(txt):
    global mp
    mp.window['TRACK'].update(txt, text_color=ERROR_COLOR)    

def reqap(arg):
    global mp, host_url
    data = None
    try:
        with urllib.request.urlopen(host_url + arg) as url:
          data = json.loads(url.read().decode('utf-8','replace'))
    except Exception as e: 
        ErrorString = e
        errorinfo(ErrorString)
    return data

def PlayCommand():
    global mp, CurrentAlbumIndex, PlayingAlbumIndex, CurrentSongIndex, PlayingSongIndex, Playing, CurrentSongs, hasHGlass
    if CurrentAlbumIndex == -1 or CurrentSongs == None or Playing or len(CurrentSongs) == 0 or hasHGlass:
        return  
    PlayingAlbumIndex = CurrentAlbumIndex
    if CurrentSongIndex < 0 or CurrentSongIndex > len(CurrentSongs) -1:
        CurrentSongIndex = 0
    reqap('?Play&album='+ str(CurrentAlbumIndex) + '&song='+ str(CurrentSongIndex))    
    mp.window['-SONG-'].set_value('')

def get_img_data_url2(f):  
    global CurrentImage, ImageSizeCur
    maxsize=ImageSizeCur
    try:
        CurrentImage = Image.open(urllib.request.urlopen(f))
        im_a = Image.new("RGB", ImageSizeCur, (48,48,48))
        aspect1 = maxsize[0]*1.0/maxsize[1]
        aspect2 = CurrentImage.size[0]*1.0/CurrentImage.size[1]
        if aspect1 > aspect2:  
            newsize = (int(aspect2 * maxsize[1]), maxsize[1])
        else:
            newsize = (maxsize[0], int(maxsize[0]/aspect2))
        img2 = CurrentImage.resize(newsize, Image.ANTIALIAS)    
        offset = ((im_a.size[0] - img2.size[0]) // 2, (im_a.size[1] - img2.size[1]) // 2)
        im_a.paste(img2, offset)
        bio = io.BytesIO()
        im_a.save(bio, format="PNG")    
        del img2
        del im_a
    except:
        return None
    return bio.getvalue()

def get_img_data2(f):    
    global CurrentImage, ImageSizeCur
    maxsize=ImageSizeCur    
    try:    
        CurrentImage = Image.open(f)                       
    except:
        CurrentImage = None
        return None
    im_a = Image.new("RGB", ImageSizeCur, (48,48,48))
    aspect1 = maxsize[0]*1.0/maxsize[1]
    aspect2 = CurrentImage.size[0]*1.0/CurrentImage.size[1]
    if aspect1 > aspect2:  
        newsize = (int(aspect2 * maxsize[1]), maxsize[1])
    else:
        newsize = (maxsize[0], int(maxsize[0]/aspect2))
    img2 = CurrentImage.resize(newsize,Image.ANTIALIAS)  
    offset = ((im_a.size[0] - img2.size[0]) // 2, (im_a.size[1] - img2.size[1]) // 2)
    im_a.paste(img2, offset)  
    bio = io.BytesIO()
    im_a.save(bio, format="PNG")    
    del img2
    del im_a
    return bio.getvalue()

def get_img_data3():    
    global CurrentImage, ImageSizeCur
    maxsize=ImageSizeCur        
    if CurrentImage is None:
        return None
    im_a = Image.new("RGB", ImageSizeCur, (48,48,48))
    aspect1 = maxsize[0]*1.0/maxsize[1]
    aspect2 = CurrentImage.size[0]*1.0/CurrentImage.size[1]
    if aspect1 > aspect2:  
        newsize = (int(aspect2 * maxsize[1]), maxsize[1])
    else:
        newsize = (maxsize[0], int(maxsize[0]/aspect2))    
    img2 = CurrentImage.resize(newsize, Image.ANTIALIAS)
    offset = ((im_a.size[0] - img2.size[0]) // 2, (im_a.size[1] - img2.size[1]) // 2)
    im_a.paste(img2, offset)  
    bio = io.BytesIO()
    im_a.save(bio, format="PNG")    
    del img2
    del im_a
    return bio.getvalue()

class MediaPlayer:
    def __init__(self):
        self.theme = 'DarkGrey' 
        self.default_bg_color = '#303030'
        self.window = self.create_window()
        try:
            urllib.request.urlopen(host_url+'/d')
            urllib.request.urlcleanup()
        except:
            pass
        self.full_info = ''
        self.Paused = False
        self.info_info = ''
    def button(self, key, image, **kwargs):
        return sg.Button(image_filename=image, border_width=0, pad=(0, 0), key=key,
                         button_color=('white', self.default_bg_color))

    def create_window(self):
        global AlbumListSize, SongListSize, BaseWindowSize, PlaylistsSize, CurrentWindowSize
        sg.change_look_and_feel(self.theme)
        col1 = [[self.button('SKIP PREVIOUS', BUTTON_DICT['START']),
                 self.button('PAUSE', BUTTON_DICT['PAUSE_OFF']),
                 self.button('PLAY', BUTTON_DICT['PLAY_OFF']),
                 self.button('STOP', BUTTON_DICT['STOP']),
                 self.button('SKIP NEXT', BUTTON_DICT['END']),                
                 self.button('PLAYLIST', BUTTON_DICT['PLAYLIST']),
                 self.button('PLUS', BUTTON_DICT['PLUS']),
                 self.button('MINUS', BUTTON_DICT['MINUS']), 
                 sg.Text('', background_color='#303030', size=(1,1), pad=(44, 0)), self.button('SOUND', BUTTON_DICT['SOUND_ON']),sg.Slider(range=(0, 100), enable_events=True, resolution=1, orientation='h', key='VOLUME', background_color='#303030')]]

        col3 = [[sg.Drop((''), size=AlbumListSize,  readonly=True, key='-ALBUM-', text_color='lightgreen', background_color='#646464', enable_events=True)],[sg.Listbox(values=(''), select_mode='single', size=SongListSize, key='-SONG-', enable_events=True, bind_return_key=True)]]
        col4 = [[self.button('RADIO', BUTTON_DICT['RADIOP']),sg.Text('', background_color='#303030', size=(4,1)), sg.Input(do_not_clear=True, enable_events=True, key='-IN-', size=(28,1)), self.button('CLOSE', BUTTON_DICT['CLOSE24'])]]
        image = get_img_data2(DEFAULT_IMG)
        my_img = sg.Image(data=image, pad=(0, 0), size=ImageSize, key='VID_OUT', background_color='#303030')
        main_layout = [ [sg.Column(col4, justification='left', background_color='#303030')],
            [sg.Column(col3, justification='center'),  sg.Column([[my_img]], justification='center')],
            [sg.Text('00:00', key='TIME_ELAPSED', background_color='#303030', size=(7,1), justification='right'),
            sg.Slider(range=(0, 1), enable_events=True, resolution=0.0001, disable_number_display=True, orientation='h', key='TIME'), sg.Text('00:00', key='TIME_TOTAL', background_color='#303030', size=(7,1))],
            [sg.Text('', key='INFO', size=(60,1), justification='left', background_color='#303030',  text_color=INFO_COLOR)],        
            [sg.Text('', key='TNUMBER', size=(3,1), justification='left', background_color='#303030',  text_color='white'), sg.Text('', key='TRACK', size=(60,1), justification='left', background_color='#303030',  text_color=TRACK_COLOR, enable_events=True)],         
            [sg.Column(col1, background_color='#303030')]]
        file_layout = [ [sg.Listbox(values=(''), size=PlaylistsSize, select_mode='single', key='PLAYLISTS', enable_events=True, bind_return_key=True, background_color='#303030')], [self.button('PLUSPL', BUTTON_DICT['PLUS']),self.button('MINUSPL', BUTTON_DICT['MINUS']),sg.Text('', background_color='#303030', size=(1,1), pad=(10, 0)), self.button('PLAYLISTOK', BUTTON_DICT['OK']), sg.Text('', background_color='#303030', size=(1,1), pad=(4, 0)),self.button('PLAYLISTCN', BUTTON_DICT['CANCEL'])]]
        layout = [[sg.Column(main_layout, key='MAIN', visible=True,  background_color='#303030'), sg.Column(file_layout, visible=False, key='FILE', background_color='#303030')]]
        window = sg.Window('Album Player', layout, font='Helvetica 13', background_color='#303030', element_justification='left', icon=ICON, finalize=True, resizable=True,  return_keyboard_events=True, use_default_focus=False, )
        window.bind('<Configure>',"Event")
        window.bind("<Return>", "Enter:13")
        window.bind("<Up>", "Up:380")        
        window.bind("<Down>", "Down:400")  
        window.bind("<Escape>", "Escape:270")      
        window.bind("<Left>", "Left:370")      
        window.bind("<Right>", "Right:390")      
        window.bind("<BackSpace>", "Backspace:377")      
        window['TIME'].expand(expand_x=True)
        window['VOLUME'].expand(expand_x=True)        
        window['TRACK'].expand(expand_x=True)
        BaseWindowSize = window.size
        # CurrentWindowSize = window.size
        return window

    def init_albums(self, data, fromrad = False):
        global RadioMode, WinHost, SongListSizeCur, AlbumListSizeCur, flag_connection, CurrentSongs, mp, host_url, Albums, CurrentSongIndex, CurrentAlbumIndex, AlbumListSize, BaseWindowSize, ImageSize, SongListSize, AlbumListSize, CurrentWindowSize
        if data != None:
                flag_connection = True      
                CurrentAlbumIndex = 0      
                   
                if len(data['Albums']) > 0:                            
                    Albums = data['Albums']
                    DataSongIndex = data['SavedSongIndex']
                    DataAlbumIndex = data['SavedAlbumIndex']
                    if DataAlbumIndex == None or DataAlbumIndex >= len(Albums):
                        DataAlbumIndex = 0                     
                    if (fromrad and not RadioMode or RadioMode) and not WinHost:
                        for index in range(len(Albums)):                          
                            pos = Albums[index].rfind('[')
                            if  pos != -1:
                                Albums[index] = Albums[index][:pos]
                    self.window['-ALBUM-'].update(values=Albums)    
                    self.SetAlbum(DataAlbumIndex)  
                    if  CurrentSongs != None and len(CurrentSongs) > 0:
                        if DataSongIndex == None or DataSongIndex >= len(CurrentSongs):
                            DataSongIndex = 0
                        self.window['-SONG-'].set_value(CurrentSongs[DataSongIndex])  
                        CurrentSongIndex = DataSongIndex
                        self.window['-SONG-'].set_vscroll_position((CurrentSongIndex - 1) * 1.0 / len(CurrentSongs))
                else:
                    self.window['-ALBUM-'].update(values=['']) 
                    self.window['-SONG-'].update(values=['']) 
                self.window['-SONG-'].set_size(SongListSizeCur)  
                self.window['-ALBUM-'].set_size(AlbumListSizeCur)            
                self.window['PLAYLISTS'].set_size(PlaylistsSizeCur)  
                if PicturesInterval > -1:
                    img = get_img_data_url2(host_url + '?GetImage&image=' + str(CurrentAlbumIndex))
                    self.window['VID_OUT'].update(data=img)           

    
    def SelectSong(self, ind):
        global CurrentSongs
        listbox =  self.window['-SONG-']  
        if CurrentSongs != None:     
            for index in range(len(CurrentSongs)):        
                if(index == ind):
                    listbox.Widget.itemconfig(index, fg='white')
                else:
                    listbox.Widget.itemconfig(index, fg='#c6fffe')
    
    def OnViewAlbum(self):
        global Playing, PlayingAlbumIndex, CurrentSongs, CurrentAlbumIndex, Albums, AlbumListSizeCur, host_url
        if not Playing:
            return
        data = reqap('?GetSongs&album=' + str(PlayingAlbumIndex))
        if data != None and len(data['Songs']) > 0:    
            CurrentSongs = data['Songs']    
            CurrentAlbumIndex = PlayingAlbumIndex
            self.window['-SONG-'].update(CurrentSongs)   
            self.window['-ALBUM-'].update(value = Albums[CurrentAlbumIndex], size=AlbumListSizeCur)    
            self.window['-ALBUM-'].set_tooltip(Albums[CurrentAlbumIndex])
            self.RotatePicture()

    def SetAlbum(self, ind):
        global Playing, CurrentSongs, PlayingAlbumIndex, CurrentAlbumIndex, CurrentSongIndex, Albums, AlbumListSizeCur, ImageSizeCur, host_url     
        data = reqap('?GetSongs&album=' + str(ind))
        if data != None and 'Songs' in data and len(data['Songs']) > 0:                
            CurrentSongs = data['Songs']    
            CurrentAlbumIndex = ind
            self.window['-SONG-'].update(CurrentSongs)   
            self.SelectSong(-1)
            self.window['-ALBUM-'].update(value = Albums[ind], size=AlbumListSizeCur)    
            self.window['-ALBUM-'].set_tooltip(Albums[ind])
            if Playing and CurrentAlbumIndex == PlayingAlbumIndex:
                self.SelectSong(PlayingSongIndex)   
            self.RotatePicture() 
        else:
            CurrentSongs = None
            CurrentAlbumIndex = -1
        CurrentSongIndex = -1

    def SelectPlaylist(self, ind):
        global Playlists
        self.load_playlist_from_file(ind)

    def RotatePicture(self):
        global  PicturesInterval, CurrentAlbumIndex, ImageSizeCur, host_url, RadioPicturesList, RadioPictureIndex, WinHost, RadioMode        
        if PicturesInterval == -1:
            return
        if RadioMode and len(RadioPicturesList) > 0 and CurrentAlbumIndex == PlayingAlbumIndex:
            RadioPictureIndex = RadioPictureIndex %  len(RadioPicturesList)
            img = get_img_data_url2(RadioPicturesList[RadioPictureIndex])    
            RadioPictureIndex += 1 
            if img == None:
                RadioPictureIndex = RadioPictureIndex %  len(RadioPicturesList)
                img = get_img_data_url2(RadioPicturesList[RadioPictureIndex])    
                RadioPictureIndex += 1 
                if img == None:
                    RadioPictureIndex = RadioPictureIndex %  len(RadioPicturesList)
                    img = get_img_data_url2(RadioPicturesList[RadioPictureIndex])    
                    RadioPictureIndex += 1 
        else:
            img = get_img_data_url2(host_url + '?GetImage&image=' + str(CurrentAlbumIndex))
        if img != None:    
            self.window['VID_OUT'].set_size(ImageSizeCur)      
            self.window['VID_OUT'].update(data=img)   

    def GetTrackInfo(self):
        global PicturesInterval, CurrentVolume, IsScanning, RadioMode, flag_connection, Albums, CurrentSongs, CurrentAlbumIndex, time_t, time_c, PlayingSongIndex, PlayingAlbumIndex, Playing, \
            label_track, AlbumListSize, WinHost, RadioPicturesList, RadioPictureIndex
        if not flag_connection:
            data = reqap('?GetAlbums')                
            self.init_albums(data)       
            return                                             
        data = reqap('?GetState')   
        if data != None:
            if data['Volume'] != CurrentVolume:
                CurrentVolume = data['Volume'] 
                if WinHost:
                    self.window['VOLUME'].update(int(CurrentVolume*100.0/255.0))
                else:
                    self.window['VOLUME'].update(int(CurrentVolume))
            if RadioMode != data['RadioMode']:
                RadioMode = data['RadioMode']
                if not RadioMode:
                    self.window['RADIO'].update(image_filename=BUTTON_DICT['RADIOP']) 
                else:
                    self.window['RADIO'].update(image_filename=BUTTON_DICT['RADIOA']) 
            if data['Playing']:
                if not Playing:
                    self.window['PLAY'].update(image_filename=BUTTON_DICT['PLAY_ON'])
                    Playing = True
                ind = data['Album']         
                new_song = False
                new_alb = False
                if PlayingAlbumIndex != ind:          
                    new_alb = True
                    new_song = True
                    PlayingAlbumIndex = ind                                                                                
                if PlayingSongIndex != data['Song']:                                
                    new_song = True
                    PlayingSongIndex = data['Song']   
                    self.window['TNUMBER'].update(str(PlayingSongIndex + 1) +'. ', text_color='white') 
                full_info_new = data['PlayingName']
                if RadioMode:
                    tm = data['Position'] // 1000                    
                    if tm % 10 == 0 or tm < 5:
                        dataR = reqap('?GetRadio')
                        rtitle = dataR['RadioTitle']
                    else:
                        rtitle = data['RadioTitle']
                    if len(rtitle) > 0:
                        full_info_new = rtitle    
                        if full_info_new != self.full_info and PicturesInterval > 0:
                                try:
                                    dataRadioPict =  reqap('?GetPictures')
                                    RadioPicturesList = dataRadioPict["Pics"]
                                    if RadioPicturesList != None and len(RadioPicturesList) > 0:
                                        RadioPictureIndex = 0
                                        self.RotatePicture()
                                except:
                                    pass
                if full_info_new != self.full_info:
                    self.window['TRACK'].update(full_info_new, text_color=TRACK_COLOR)   
                    self.full_info = full_info_new
                if data['Paused'] != self.Paused:
                    self.Paused = data['Paused']
                    if self.Paused:
                        self.window['PAUSE'].update(image_filename=BUTTON_DICT['PAUSE_ON'])
                    else:
                        self.window['PAUSE'].update(image_filename=BUTTON_DICT['PAUSE_OFF'])
                new_info_info = '               '                
                if data['Freq'] > 0 and data['Bitrate'] > 0:        
                    new_info_info += str(data['Bitrate']) + ' kbps • '
                    cur_freq = data['Freq']
                    if not WinHost:
                        cur_freq /= 1000
                    if cur_freq > 1000:
                        new_info_info += str(cur_freq / 1000) +' MHz • '
                    else:
                        new_info_info += str(int(cur_freq)) +' kHz • '          
                    new_info_info += str(data['Bps']) + ' bit'    
                if new_info_info != self.info_info:      
                    self.info_info = new_info_info
                    self.window['INFO'].update(new_info_info)
                time_t_new =  data['PlayingLen']
                if time_t_new != time_t:
                    time_t = time_t_new
                    (m,s) = divmod( time_t // 1000, 60)
                    if m > 59:
                        (mm,ss) = divmod( m, 60)
                        time_total = "{:01d}:{:02d}:{:02d}".format(mm, ss, s)  
                    else:
                        time_total = "{:02d}:{:02d}".format(m,s)
                    self.window['TIME_TOTAL'].update(time_total)
                time_c = data['Position']   
                time_c_sec =  time_c // 1000
                if Playing and PicturesInterval > 0 and time_c_sec > 0 and time_c_sec % PicturesInterval == 0: 
                    mp.RotatePicture()
                (m2, s2) = divmod( time_c_sec, 60)                
                if m2 > 59:
                    (mm,ss) = divmod( m2, 60)
                    time_current = "{:01d}:{:02d}:{:02d}".format(mm, ss, s2) 
                else:
                    time_current = "{:02d}:{:02d}".format(m2,s2)
                self.window['TIME_ELAPSED'].update(time_current)                
                self.window['TIME'].update(1.0 * time_c / time_t )
                if CurrentAlbumIndex == data['Album']: 
                    if new_song:                        
                        self.SelectSong(PlayingSongIndex)
                else: 
                    if new_alb:                        
                        self.OnViewAlbum()    
                        self.SelectSong(PlayingSongIndex)                    
            else:
                self.window['PAUSE'].update(image_filename=BUTTON_DICT['PAUSE_OFF'])
                if Playing:                    
                    Playing = False                        
                    mp.stop()
                if IsScanning:
                    if data['Scanning']:
                        data2 =  reqap('?GetPath')   
                        if data2 != None:
                            self.window['TRACK'].update('Scanning... ' + data2['Path'])
                    else:
                        IsScanning = False
                        self.window['TRACK'].update('')
                        data3 = reqap('?GetAlbums')  
                        self.init_albums(data3)
                else:
                    self.window['TRACK'].update('')
                    self.window['TNUMBER'].update('')
                    self.window['INFO'].update('')

    def play(self):
        global CurrentSongIndex, CurrentAlbumIndex, PlayingSongIndex, time_t, CurrentSongs 
        if Playing and self.Paused:
            reqap('?Pause')
        else:
            if  CurrentSongs != None and CurrentAlbumIndex != -1:
                self.window['PLAY'].update(image_filename=BUTTON_DICT['PLAY_ON'])
                self.window['PAUSE'].update(image_filename=BUTTON_DICT['PAUSE_OFF']) 
                PlayCommand()
            PlayingSongIndex = -1
            time_t = -1
            self.full_info = ''

    def toggle_radio(self):
        data = reqap('?RadioMode')
        self.init_albums(data, True)      

    def stop(self):     
        global RadioMode, WinHost, RadioPicturesList
        self.window['PLAY'].update(image_filename=BUTTON_DICT['PLAY_OFF'])
        self.window['PAUSE'].update(image_filename=BUTTON_DICT['PAUSE_OFF'])
        self.window['TIME'].update(value=0)
        self.window['TIME_ELAPSED'].update('00:00')
        self.window['TIME_TOTAL'].update('00:00')
        self.SelectSong(-1)
        reqap('?Stop')
        if RadioMode and len(RadioPicturesList) > 0:
            RadioPicturesList.clear()
            self.RotatePicture()

    def pause(self):
        global Playing
        if Playing:
              reqap('?Pause')

    def skip_next(self):
        if Playing and self.Paused:
            reqap('?Pause')
        reqap('?Next')        

    def skip_previous(self):
        if Playing and self.Paused:
            reqap('?Pause')
        reqap('?Prev')    

    def load_playlist_from_file(self, ind):
        global Playlists, CurrentPlaylistIndex, WinHost
        self.window['MAIN'].update(visible=False)        
        self.window['FILE'].update(visible=True)
        data = reqap('?GetPlaylists&ind=' + str(ind))
        if data != None and len(data['Drives']) > 0:   
            Playlists = list() 
            for Line in data['Drives']:
                if Line['level'] == 0:
                    if WinHost or Line['path'] == '':
                        val = Line['name']                                        
                    else:                        
                        if(Line['expanded']) == 1:
                            val = '\u229F ' + Line['name']                        
                        else:
                            val = '\u229E ' + Line['name']                        
                    if Line['path'] == '.':
                        if(Line['expanded']) == 1:
                            val = '\u229F Root'                    
                        else:
                            val = '\u229E Root'                    
                else:   
                    val = ''
                    for x in range(Line['level']):                        
                        val += '  '
                    if Line['expanded'] == 1:
                        val += '\u229F ' +  Line['name']
                    elif Line['expanded'] == 0:
                        val += '\u229E ' +  Line['name']                    
                    else:
                        val += '  ' +  Line['name'] 
                Playlists.append(val)    
            self.window['PLAYLISTS'].update(Playlists)      
            if CurrentPlaylistIndex > -1 and CurrentPlaylistIndex < len(Playlists):
                self.window['PLAYLISTS'].SetValue(Playlists[CurrentPlaylistIndex])                
                self.window['PLAYLISTS'].set_vscroll_position((CurrentPlaylistIndex - 1)* 1.0 / len(Playlists))
    
    def set_position(self, pos):      
        global WinHost
        if WinHost:  
            position = int(232*pos)
        else:
            position = int(100*pos)
        reqap('?Position&pos=' + str(position))
    
    def resize(self, tmp_sz):
            global config, CurrentWindowSize, BaseWindowSize, SongListSize, SongListSizeCur, PlaylistsSize, PlaylistsSizeCur, AlbumListSize, AlbumListSizeCur, ImageSize, ImageSizeCur
            #tmp_sz = self.window.size
            scaleX = tmp_sz[0] * 1.0 / BaseWindowSize[0]
            scaleY = tmp_sz[1] * 1.0 / BaseWindowSize[1]
            scaleYY = scaleY 
            if tmp_sz[1] > BaseWindowSize[1]:
                 scaleYY = scaleY * 1.0
            if tmp_sz[1] < BaseWindowSize[1]:
                 scaleYY  =  scaleY / 1.2
            tmp  = (int(scaleX * SongListSize[0]), int(scaleYY * SongListSize[1]))
            self.window['-SONG-'].set_size(tmp)  
            SongListSizeCur = tmp
            tmp  = (int(scaleX * PlaylistsSize[0]), int(scaleY * PlaylistsSize[1]))
            self.window['PLAYLISTS'].set_size(tmp)  
            PlaylistsSizeCur = tmp
            tmp = (int(scaleX * AlbumListSize[0]), int(scaleYY * AlbumListSize[1]))
            self.window['-ALBUM-'].set_size(tmp)  
            AlbumListSizeCur = tmp            
            tmp = (int(scaleX * ImageSize[0]), int(scaleY * ImageSize[1]))
            self.window['VID_OUT'].set_size(tmp) 
            ImageSizeCur = tmp           
            self.window['VID_OUT'].update(data=get_img_data3())  
            CurrentWindowSize = tmp_sz
            self.window.size = tmp_sz
            config['SETTINGS']['windowsize'] =  str(CurrentWindowSize)

def main():
    global CurrentWindowLocation, config, host_url, PicturesInterval, Playing, WinHost, AddMode, IsScanning, ImageSizeCur, AlbumListSizeCur, SongListSizeCur, CurrentSongs, mp, Albums, CurrentSongIndex, CurrentPlaylistIndex, CurrentAlbumIndex, AlbumListSize, BaseWindowSize, ImageSize, SongListSize, AlbumListSize, CurrentWindowSize, Playlists, PlaylistsSize, PlaylistsSizeCur
    config['SETTINGS'] = {'url': 'http://127.0.0.1:100', 'interval': '20', 'windowsize': '(800,600)', 'windowlocation': '(-20,-20)'}    
    try:
        config.read('ap2gui.config')
    except:
        pass
    host_url = config['SETTINGS']['url']
    PicturesInterval = int(config['SETTINGS']['interval'])
    if host_url.find(":7778") != -1:
        WinHost = False
    CurrentWindowSize =  eval(config['SETTINGS']['windowsize'])   
    CurrentWindowLocation =  eval(config['SETTINGS']['windowlocation'])       
    mp = MediaPlayer()
    data = reqap('?GetAlbums')
    mp.init_albums(data)
    if mp.window.size !=  CurrentWindowSize:
        mp.resize(CurrentWindowSize)
    if (CurrentWindowLocation[0] > -20) and (CurrentWindowLocation != mp.window.CurrentLocation()):
        mp.window.Move(CurrentWindowLocation[0], CurrentWindowLocation[1])     
    while True:
        event, values = mp.window.read(timeout=1000)
        if event in (None, 'Exit'):
            break  
        try:
            # if mp.window.TKroot.state() != 'iconic' and mp.window.TKroot.focus_displayof() != None:
            if mp.window.TKroot.state() != 'iconic':
                mp.GetTrackInfo()
                CurrentWindowLocation = mp.window.CurrentLocation()      
        except:
            pass
        if event == "Event":
            if CurrentWindowSize  == mp.window.size:
                continue
            else:
                mp.resize(mp.window.size)
            continue
        elif event == 'PLAY' or (event == 'Enter:13' and mp.window['MAIN'].visible and not Playing):
            #if event == 'Enter:13' and Playing:
            #    mp.stop()  
            #    Playing = False;                   
            #    mp.play()
            #el
            if not IsScanning:  
                mp.play()
            continue
        elif event == 'PAUSE' or event == 'Backspace:377' and not  (mp.window['-IN-']  == mp.window.find_element_with_focus()):
            mp.pause()
            continue
        elif Playing and (event == 'Enter:13') and mp.window['MAIN'].visible:
            mp.stop()
            Playing = False
            mp.play()
            continue
        elif event == 'SKIP NEXT' or (event == 'Right:390' and mp.window['MAIN'].visible):
            mp.skip_next()
            continue
        elif event == 'SKIP PREVIOUS' or (event == 'Left:370' and mp.window['MAIN'].visible):
            if Playing:
                mp.skip_previous()
            elif event == 'Left:370' and not (mp.window['-IN-']  == mp.window.find_element_with_focus()):
                mp.toggle_radio()               
            continue
        elif event == 'STOP':
            mp.stop()
            continue
        elif event == 'RADIO':
            mp.toggle_radio()
            continue
        elif event == '-IN-' or  event == 'Backspace:377' and  (mp.window['-IN-']  == mp.window.find_element_with_focus()):
            Albums2 = [elem for elem in Albums if elem.lower().find(values['-IN-'].lower()) != -1]
            if Albums2 != None and len(Albums2) > 0:
                mp.window['-ALBUM-'].update(values=Albums2 , value = Albums2[0], size=AlbumListSizeCur)
                mp.SetAlbum(Albums.index(Albums2[0]))      
            else:
                Albums2 = []
                mp.window['-ALBUM-'].update(values=Albums2 , size=AlbumListSizeCur)
                mp.window['-SONG-'].update(values=['']) 
                CurrentSongs = None
                CurrentAlbumIndex = -1
            continue
        elif event == '-ALBUM-':
            ind = Albums.index(values['-ALBUM-'])
            mp.SetAlbum(ind)
            mp.window['VID_OUT'].set_focus()    
            continue
        elif event == '-SONG-':
            if CurrentAlbumIndex == -1 or CurrentSongs == None:
                continue
            ind = mp.window['-SONG-'].GetIndexes()            
            if len(ind) > 0 and ind[0] >= 0 and ind[0] < len(CurrentSongs):
                if CurrentSongIndex == ind[0] and not IsScanning:  
                    if Playing:
                        mp.stop()  
                        Playing = False;                   
                    mp.play()
                else:
                    CurrentSongIndex = ind[0]  
                    if not Playing:
                        path_data = reqap('?GetPath&album=' + str(CurrentAlbumIndex) + '&song=' + str(CurrentSongIndex))
                        mp.window['TRACK'].update(path_data["Path"], text_color=TRACK_COLOR)   

                #mp.window['-ALBUM-'].set_focus()                
                mp.window['VID_OUT'].set_focus()                
            continue
        elif event == 'PLAYLISTS'  or (event == 'Enter:13' and mp.window['FILE'].visible):
            ind = mp.window['PLAYLISTS'].GetIndexes()     
            if len(ind) > 0:
                if ind[0] != CurrentPlaylistIndex:
                    CurrentPlaylistIndex = ind[0]                    
                else:
                    if ind[0] >= 0 and ind[0] < len(Playlists):
                        mp.SelectPlaylist(ind[0])    
                    mp.window['PLAYLISTS'].set_vscroll_position(ind[0] * 1.0 / len(Playlists))
            mp.window['PLAYLISTOK'].set_focus()
            continue
        elif event == 'TIME':
            if Playing and mp.Paused:
                reqap('?Pause')
            mp.set_position(values['TIME'])
            continue
        elif event == 'PLUS':
            if RadioMode:
                mp.toggle_radio()
            if len(values['-IN-']) > 0:
                mp.window['-IN-'].update('')   
                if Albums != None and len(Albums) > 0:
                    mp.window['-ALBUM-'].update(values=Albums , value = Albums[0], size=AlbumListSizeCur)
                    mp.SetAlbum(Albums.index(Albums[0]))                    
            AddMode = True
            mp.load_playlist_from_file(0)            
            continue
        elif Playing and event == 'Escape:270':
            mp.stop()
            continue
        elif event == 'PLAYLIST' or (event == 'Escape:270' and mp.window['MAIN'].visible):
            if RadioMode:
                mp.toggle_radio()
            if len(values['-IN-']) > 0:
                mp.window['-IN-'].update('')   
                if Albums != None and len(Albums) > 0:
                    mp.window['-ALBUM-'].update(values=Albums , value = Albums[0], size=AlbumListSizeCur)
                    mp.SetAlbum(Albums.index(Albums[0]))                    
            AddMode = False
            mp.load_playlist_from_file(0)
            continue
        elif event == 'PLAYLISTOK' or (event == 'Escape:270' and mp.window['FILE'].visible):
            if CurrentPlaylistIndex > -1 and CurrentPlaylistIndex < len(Playlists):
                if AddMode:
                    reqap('?Get_Playlist&playlist=' + str(CurrentPlaylistIndex))
                else:
                    reqap('?GetPlaylist&playlist=' + str(CurrentPlaylistIndex))
                IsScanning = True
            mp.window['FILE'].update(visible=False)        
            mp.window['MAIN'].update(visible=True)
            continue
        elif event == 'PLAYLISTCN' or (event == 'Left:370' and mp.window['FILE'].visible):
            mp.window['FILE'].update(visible=False)        
            mp.window['MAIN'].update(visible=True)
            continue
        elif event == 'MINUS':    
            if Albums != None and len(Albums) > 0:
                data=reqap('?DeleteAlbum&album=' + str(CurrentAlbumIndex))
                mp.init_albums(data)
            continue
        elif event == 'MINUSPL':                
                ind = mp.window['PLAYLISTS'].GetIndexes()            
                if len(ind) > 0 and ind[0] > 0:                                     
                    reqap('?DeletePlaylist&name=' + Playlists[ind[0]])                                  
                    mp.load_playlist_from_file(0)
                continue
        elif event == 'PLUSPL':                
                text = sg.popup_get_text('Please enter the playlist name', 'Saving a new playlist')
                if text != None and len(text) > 0:
                    reqap('?SavePlaylist&name=' + text)
                    mp.load_playlist_from_file(0)
                continue
        elif event == 'CLOSE':
            mp.window['-IN-'].update('')     
            if Albums != None and len(Albums) > 0:
                mp.window['-ALBUM-'].update(values=Albums , value = Albums[0], size=AlbumListSizeCur)
                mp.SetAlbum(0)                
            continue
        elif event == 'VOLUME':
            if WinHost:
                CurrentVolume = int(values['VOLUME'] * 255.0 / 100.0)
            else:
                CurrentVolume = int(values['VOLUME'])
            reqap('?SetVolume&volume=' + str(CurrentVolume))                  
            continue
        elif event == 'TRACK' and Playing:
            mp.OnViewAlbum()    
            mp.SelectSong(PlayingSongIndex)  
            continue
        elif event == 'Up:380':
            if mp.window['FILE'].visible:            
                if CurrentPlaylistIndex > 0 and CurrentPlaylistIndex < len(Playlists):
                    CurrentPlaylistIndex -= 1
                else:
                    CurrentPlaylistIndex = 0
                mp.window['PLAYLISTS'].SetValue(Playlists[CurrentPlaylistIndex])
                mp.window['PLAYLISTS'].set_vscroll_position((CurrentPlaylistIndex - 1) * 1.0 / len(Playlists))
            else:    
                if CurrentAlbumIndex == -1 or CurrentSongs == None or IsScanning:
                    continue
                ind = mp.window['-SONG-'].GetIndexes()            
                if len(ind) > 0 and ind[0] >= 0 and ind[0] < len(CurrentSongs):
                    if CurrentSongIndex == -1:  
                        mp.window['-ALBUM-'].set_focus()   
                        mp.window['-ALBUM-'].Widget.event_generate('<Down>')

                    else:
                        CurrentSongIndex -= 1  
                        if CurrentSongIndex == -1:  
                            mp.window['-SONG-'].SetValue('')  
                            mp.window['-ALBUM-'].set_focus()  
                            mp.window['-ALBUM-'].Widget.event_generate('<Down>')
                        else:
                            mp.window['-SONG-'].SetValue(CurrentSongs[CurrentSongIndex])    
                            mp.window['-SONG-'].set_vscroll_position((CurrentSongIndex - 1)* 1.0 / len(CurrentSongs))
                else:
                    mp.window['-SONG-'].SetValue('')  
                    mp.window['-ALBUM-'].set_focus()   
                    mp.window['-ALBUM-'].Widget.event_generate('<Down>')
            continue
        elif event == 'Down:400':
            if mp.window['FILE'].visible:            
                if CurrentPlaylistIndex > -1 and CurrentPlaylistIndex < len(Playlists) - 1:
                    CurrentPlaylistIndex += 1
                elif CurrentPlaylistIndex == len(Playlists) - 1:
                    pass    
                else:
                    CurrentPlaylistIndex = 0
                mp.window['PLAYLISTS'].SetValue(Playlists[CurrentPlaylistIndex])
                mp.window['PLAYLISTS'].set_vscroll_position((CurrentPlaylistIndex - 1)* 1.0 / len(Playlists))
            else:
                if CurrentAlbumIndex == -1 or CurrentSongs == None or IsScanning or len(CurrentSongs) < 1:
                    continue
                ind = mp.window['-SONG-'].GetIndexes()            
                if len(ind) > 0 and ind[0] >= 0:
                    CurrentSongIndex += 1      
                    if CurrentSongIndex >= len(CurrentSongs):
                        CurrentSongIndex = -1
                        mp.window['-SONG-'].SetValue('')  
                        mp.window['-ALBUM-'].set_focus()   
                        mp.window['-ALBUM-'].Widget.event_generate('<Down>')
                        continue
                else:
                    CurrentSongIndex = 0  
                mp.window['-SONG-'].SetValue(CurrentSongs[CurrentSongIndex])    
                mp.window['-SONG-'].set_vscroll_position((CurrentSongIndex - 1) * 1.0 / len(CurrentSongs))
    config['SETTINGS']['windowlocation'] = str(CurrentWindowLocation)               
    with open('ap2gui.config', 'w') as configfile:
        config.write(configfile)

if __name__ == '__main__':
    main()
